# This YAML configures Gitlb CI for test builds and deployment of VisNow project.
# Job 'test-build' builds VisNow and is executed on every push to 'develop' branch (it is not executed on scheduled pipelines).
# Job 'deploy-daily' builds VisNow, builds installers with InstallBuilder, and uploads installerts to FTP server. It is 
# executed only on the scheduled pipelines. The deployment execution is conditioned inside gitlab-ci-deploy.sh script. 
# Gitlab commit SHA vs. last build commit SHA stored in last_daily_build file is used to determine if a last deployed build 
# is up to date. 

variables:
    # DOCKER_AUTH_CONFIG is a configuration variable for Container Registry authorization, to retrieve docekr image.
    DOCKER_AUTH_CONFIG: "{\"auths\": {\"registry.gitlab.com\": {\"auth\": \"${REGISTRY_AUTH}\"}}}"


# Docker image from visnow.org/visnow-deploy-docker project is used.
image: "$CI_REGISTRY/visnow.org/visnow-deploy-docker/openjdk-8-installbuilder:latest"


# Cache downloaded maven dependencies and plugins between builds.
cache:
    paths:
        - .m2/repository
    
    
stages:
  - build
  - deploy


test-build:
    stage: build
    script:
        - mvn -version
        - ant -version
        - pwd
        - ls -la
        - mvn dependency:copy-dependencies -Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=./.m2/repository -DoutputDirectory=./deps 
        - mvn dependency:copy-dependencies -Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=./.m2/repository -DoutputDirectory=./deps -Dclassifier=sources
        - mkdir -p ../JSciC/target
        - cp ./deps/JSciC* ../JSciC/target/
        - ls ../JSciC/target/
        - mkdir -p ../JViA/target
        - cp ./deps/JViA* ../JViA/target/
        - ls ../JViA/target/
        - ant jar -v -Dlibs.CopyLibs.classpath=/root/org-netbeans-modules-java-j2seproject-copylibstask.jar
        - ls -la dist
    only:
        refs:
            - develop
    except:
        refs:
            - schedules
            
deploy-daily:
    stage: deploy
    needs:
        - project: $CI_PROJECT_PATH
          job: deploy-daily
          ref: develop
          artifacts: true
    script:
        - mvn -version
        - ant -version
        - pwd
        - ls -la
        - chmod +x gitlab-ci-deploy.sh
        - ./gitlab-ci-deploy.sh
        - echo $CI_COMMIT_SHA > last_daily_build
    artifacts:
        paths:
            - last_daily_build        
    only:
        refs:
            - schedules  
            
